#!/usr/bin/env node
import{run as ot}from'jest';import{ESLint as se}from'eslint';import st from'postcss-nested';import tt from'postcss-simple-vars';import et from'cssnano';import Xe from'autoprefixer';import{eslint as Qe}from'rollup-plugin-eslint';import Ze from'rollup-plugin-progress';import Ve from'rollup-plugin-filesize';import Ue from'rollup-plugin-strip-code';import Ke from'rollup-plugin-postcss';import Ye from'rollup-plugin-typescript2';import He from'@rollup/plugin-babel';import qe from'@rollup/plugin-beep';import Ge from'@rollup/plugin-json';import ze from'@rollup/plugin-image';import Le from'@rollup/plugin-url';import We from'@rollup/plugin-node-resolve';import Re from'@rollup/plugin-commonjs';import Ie from'@ampproject/rollup-plugin-closure-compiler';import{rollup as Fe,watch as Me}from'rollup';import{Input as te,Select as H}from'enquirer';import D from'ora';import b from'execa';import l from'path';import d,{outputJSON as Be}from'fs-extra';import{bold as E,yellow as De,cyan as Oe,blue as Je,red as Ee,green as Te,inverse as _e,underline as Ae}from'colorette';import{always as Ne,pipe as B}from'ramda';import Se,{exec as v}from'shelljs';import Ce from'sade';function k(a){v(`npm config set init-author-name "${a}"`,{silent:!0})}function aa(){var a=v("npm config get init-author-name",{silent:!0}).stdout.trim();return a?a:(a=v("git config user.name",{silent:!0}).stdout.trim())?(k(a),a):(a=v("npm config get init-author-email",{silent:!0}).stdout.trim())?a:v("git config user.email",{silent:!0}).stdout.trim()||null}
let ba=Ne(void 0),q={info:a=>B(E,Oe)(a),details:a=>B(E,Je)(a),error:a=>B(E,Ee)(a),success:a=>B(E,Te)(a),highlight:a=>B(E,De)(a),bold:a=>E(a),inverse:a=>_e(a),underline:a=>Ae(a)};function r(){process.stdout.write("win32"===process.platform?"\u001b[2J\u001b[0f":"\u001b[2J\u001b[3J\u001b[H")}let t=(a="")=>{let c="";for(let e=0;e<a.length;e+=1)" "!==a[e]&&(c+=a[e]);return""===c?new Map:new Map(c.split(",").map(e=>[e,!0]))};
var w={name:"monoreact",version:"0.32.1",description:"React workspaces implementation",license:"MIT",main:"./dist/bundle.cjs",bin:{monoreact:"./dist/bundle.cjs"},author:{email:"tarsis.maksym@gmail.com",name:"Maksym Tarsis",url:"https://github.com/untaggable"},repository:{type:"git",url:"https://github.com/untaggable/monoreact.git"},homepage:"https://github.com/untaggable/monoreact#readme",bugs:"https://github.com/untaggable/monoreact/issues",scripts:{start:"yarn build -w",build:"rollup -c rollup.config.js",
lint:'eslint "src/**/*.{js,jsx,ts,tsx}"',test:"jest",prepublishOnly:"yarn build && yarn test"},dependencies:{"@ampproject/rollup-plugin-closure-compiler":"0.27.0","@babel/cli":"7.16.7","@babel/core":"7.16.7","@babel/plugin-proposal-class-properties":"7.16.7","@babel/plugin-transform-runtime":"7.16.7","@babel/preset-env":"7.16.7","@babel/preset-react":"7.16.7","@babel/runtime":"7.16.7","@rollup/plugin-babel":"5.3.0","@rollup/plugin-beep":"0.2.0","@rollup/plugin-commonjs":"21.0.1","@rollup/plugin-image":"2.1.1",
"@rollup/plugin-json":"4.1.0","@rollup/plugin-node-resolve":"13.1.3","@rollup/plugin-url":"6.1.0","@typescript-eslint/eslint-plugin":"5.9.0","@typescript-eslint/parser":"5.9.0",autoprefixer:"10.4.2","babel-jest":"27.4.6",colorette:"2.0.16",cssnano:"5.0.15",enquirer:"2.3.6",eslint:"8.6.0","eslint-config-prettier":"8.3.0","eslint-config-react-app":"6.0.0","eslint-import-resolver-typescript":"2.5.0","eslint-plugin-compat":"4.0.1","eslint-plugin-flowtype":"8.0.3","eslint-plugin-import":"2.25.4","eslint-plugin-jsx-a11y":"6.5.1",
"eslint-plugin-prettier":"4.0.0","eslint-plugin-react":"7.28.0","eslint-plugin-react-hooks":"4.3.0",execa:"5.1.1","fs-extra":"10.0.0","identity-obj-proxy":"3.0.0",jest:"27.4.7","node-sass":"7.0.1",ora:"5.4.1",postcss:"8.4.5","postcss-nested":"5.0.6","postcss-simple-vars":"6.0.3",ramda:"0.27.1",react:"17.0.2","react-dom":"17.0.2",rollup:"2.63.0","rollup-plugin-analyzer":"4.0.0","rollup-plugin-eslint":"7.0.0","rollup-plugin-filesize":"9.1.1","rollup-plugin-postcss":"4.0.2","rollup-plugin-progress":"1.1.2",
"rollup-plugin-size-snapshot":"0.12.0","rollup-plugin-strip-code":"0.2.7","rollup-plugin-typescript2":"0.31.1","rollup-plugin-visualizer":"5.5.2",sade:"1.8.1",shelljs:"0.8.5","ts-jest":"27.1.2",tslib:"2.3.1",typescript:"4.5.4"},devDependencies:{"@types/eslint":"8.2.2","@types/fs-extra":"9.0.13","@types/jest":"27.4.0","@types/node":"16.11.17","@types/ramda":"0.27.62","@types/react":"17.0.38","@types/sade":"1.7.4","@types/shelljs":"0.8.10",esbuild:"0.14.11","rollup-plugin-esbuild":"4.8.2","rollup-plugin-node-builtins":"2.1.2",
"rollup-plugin-node-globals":"1.4.0","rollup-plugin-preserve-shebangs":"0.2.0",yarn:"1.22.17"},publishConfig:{access:"public"},workspace:!0,keywords:"cli microfrontend workspaces submodules monorepo react typescript rollup".split(" ")};
let ca={start:"npx monoreact watch",build:"npx monoreact build",test:"npx monoreact test --passWithNoTests",lint:'npx monoreact lint "src/**/*.{js,jsx,ts,tsx}"',prepublishOnly:"yarn build"},da={...ca,stylelint:'npx stylelint "src/**/*.{css,sass,scss}"'},ea={peerDependencies:{react:"*"}},fa={name:void 0,author:void 0,workspace:!0,private:!1,version:"0.1.0",main:"dist/bundle.cjs.js",module:"dist/bundle.js",types:"dist/publicApi.d.ts",source:"src/publicApi.ts",publishConfig:{access:"public"}},ha={name:void 0,
author:void 0,version:"0.1.0",private:!0,license:"MIT",workspaces:[],scripts:{start:"react-scripts start",build:"react-scripts build",test:"react-scripts test",eject:"react-scripts eject",lint:"monoreact lint",stylelint:'stylelint "src/**/*.{css,sass,scss}"'},dependencies:{react:"^17.0.2","react-dom":"^17.0.2","react-scripts":"5.0.0"},devDependencies:{monoreact:"latest","@testing-library/jest-dom":"^5.16.1","@testing-library/react":"^12.1.2","@testing-library/user-event":"^13.5.0","web-vitals":"^2.1.2",
"@types/jest":"^27.0.3","@types/react":"^17.0.37","@types/react-dom":"^17.0.11","@types/node":w.devDependencies["@types/node"],"@typescript-eslint/eslint-plugin":"5.7.0","@typescript-eslint/parser":"5.7.0","eslint-config-prettier":w.dependencies["eslint-config-prettier"],"eslint-config-react-app":w.dependencies["eslint-config-react-app"],"eslint-plugin-prettier":w.dependencies["eslint-plugin-prettier"],"eslint-plugin-promise":"5.2.0","eslint-plugin-react":w.dependencies["eslint-plugin-react"],"eslint-plugin-react-hooks":w.dependencies["eslint-plugin-react-hooks"],
"eslint-plugin-import":w.dependencies["eslint-plugin-import"],"eslint-plugin-sonarjs":"0.11.0","eslint-plugin-jsx-a11y":w.dependencies["eslint-plugin-jsx-a11y"],husky:"4.3.8","lint-staged":"12.1.2",prettier:"2.5.1",stylelint:"14.1.0","stylelint-config-recommended":"3.0.0",tslib:w.dependencies.tslib,typescript:w.dependencies.typescript,yarn:w.devDependencies.yarn},browserslist:{production:[">0.2%","not dead","not op_mini all"],development:["last 1 chrome version","last 1 firefox version","last 1 safari version"]}},
ia=async()=>{var a=process.cwd();a=l.resolve(a,"dist");await d.remove(a)},y=(...a)=>l.resolve(__dirname,"../templates",...a),ja=async a=>{a=a.map(c=>d.readJSON(l.resolve(c.location,"package.json")));return(await Promise.allSettled(a)).map(c=>c.value)},ka=a=>{const c=[],e=Object.fromEntries(a.map(({name:h,dependencies:g={},devDependencies:m={},peerDependencies:n={}})=>[h,{...g,...m,...n}])),f=new Map;for(const h in e)f.set(h,Object.keys(e[h]).filter(g=>void 0!==e[g]));for(a=Array.from(f.keys()).reduce((h,
g)=>0<f.get(g).length?h:[...h,g],[]);0<a.length;){c.push(a);for(const h of a)f.delete(h);a=Array.from(f.keys()).filter(h=>{var g,m;const n=null!=(m=null==(g=f.get(h))?void 0:g.filter(p=>f.has(p)))?m:[];return f.set(h,n),0===n.length})}return{chunks:c,unprocessed:Array.from(f.entries())}},la=({dependencies:a={},peerDependencies:c={},devDependencies:e={}})=>{const f=[...Object.keys(a),...Object.keys(c),...Object.keys(e)],h=new Map(f.map(g=>[g,g]));return g=>h.has(g)||!!f.find(m=>g.startsWith(`${m}/`))},
z=console.error.bind(console);function A(a){a=a.error||a;var c=a.name?`${a.name} `:"";let e=a.message||a;c=c?`${c} ${e}`:e;c=a.plugin?"rpt2"===a.plugin?`(typescript) ${c}`:`(${a.plugin} plugin) ${c}`:c;process.stdout.write("\n");a.stack?z(q.error(a.stack)):(z(q.error(c)),a.loc&&z(`at ${a.loc.file}:${a.loc.line}:${a.loc.column}`),process.stdout.write("\n"),a.frame&&z(q.error(a.frame)));process.stdout.write("\n")}
let C=async()=>{var a=v("git submodule foreach --quiet 'echo $name'",{silent:!0});({stdout:a}=a);return a.trim().split("\n")};Se.config.silent=!0;let ma=process.cwd();l.join(ma,"test",".staging");class na extends Error{constructor(){super("\n    \n    Can't find workspace\n    Make sure you run the script inside the project\n      ");this.isNotFoundHostError=!0;this.name="Not Found Workspace Error"}}
class oa extends Error{constructor(){super("\n    \n    Can't find workspace package\n    Make sure you run the script inside the package\n        \n    The workspace package.json should have:\n        workspace: true;\n        private: false;\n      ");this.isNotFoundPackageError=!0;this.name="Not Found Workspace Error"}}
let pa=a=>{var c;return void 0===a?[]:"packages"in a?null!=(c=a.packages)?c:[]:a},qa=a=>{if(0===a.length)return"packages";const c=a.find(e=>"*"===e[e.length-1]);return void 0!==c?c.slice(0,c.length-2):a[0].split("/").filter(Boolean).slice(0,-1).join("/")};async function ra(){let a=await G(),c=v("yarn workspaces --json info",{cwd:a,silent:!0}).stdout.trim(),e=JSON.parse(JSON.parse(c).data);return Object.keys(e).reduce((f,h)=>[...f,{name:h,location:l.resolve(a,e[h].location)}],[])}
let sa=({packages:a,packageName:c,setupPath:e})=>{e=e.split("/").filter(f=>"."!==f&&""!==f).join("/");c=""===e?c:`${e}/${c}`;e=""===e?"*":`${e}/*`;for(const f of a)if(f===e||f===c)return a;return a.concat(c)},G=async(a=!1)=>{async function c(f){if(10>f.length)return null;var h=l.resolve(f,"package.json"),g;if(g=d.existsSync(h))h=await d.readJSON(h),g=void 0!==h.workspaces&&h.private;return g?f:c(l.resolve(f,".."))}var e=await c(await d.realpath(process.cwd()));if(null!==e)return e;e=new na;if(a)throw e;
A(e);process.exit(1)},I=async(a=!1)=>{async function c(f){var h=l.resolve(f,"package.json"),g={};d.existsSync(h)&&(g=await d.readJSON(h));h=10>f.length;const m=void 0!==g.workspaces&&g.private;g=g.workspace&&!g.private;switch(!0){case h||m:return null;case g:return f;default:return c(l.resolve(f,".."))}}var e=await c(await d.realpath(process.cwd()));if(null!==e)return e;e=new oa;if(a)throw e;A(e);process.exit(1)},ta=q.highlight("\n  M O N O R E A C T\n    "),K={exists:()=>q.error("\n    It seems like you already have this feature.\n        "),
invalidFeatureName:a=>{a=q.inverse(` ${a} `);return q.error(`
  Invalid feature name
  Unfortunately, monoreact doesn't provide ${a} feature
        `)},adding:a=>`Adding ${q.info(a)} feature...`,successful:a=>`Added ${q.success(a)} feature template`,failed:a=>`Failed to add ${q.error(a)} feature template`},ua={bundling:({source:a,module:c})=>q.info(`${a} \u2192 ${c}`),successful:([a,c])=>q.success("Compiled in ")+q.highlight(`${a}.${c.toString().slice(0,3)}s.`)},L={copy:a=>`${a}-copy`,successful:a=>`Generated ${q.info(a)} package`,generating:a=>`Generating ${q.info(a)} package...`,failed:a=>`Failed to generate ${q.error(a)} package`,
successfulConfigure:()=>"The package successfully configured",failedConfigure:()=>"Failed to fully configure the package",invalidTemplate:a=>`Invalid template ${q.error(a)}`,exists:a=>`A folder named ${q.error(a)} already exists! ${q.bold("Choose a different name")}`,preparingPackage:(a,c)=>{const e=c.map(f=>`     ${q.info(f)}`).join("\n");a=`Preparing ${q.info(a)} package`;return 0<c.length?`${a} with the following peer dependencies: 
${e}
`:a},preparedPackage:a=>`
  ${q.success("Awesome!")} You're now ready to start coding.
  
  There is no need to run ${q.info("monoreact install")}, since all peer dependencies are already in the workspace root
  
  So your next steps are:
    ${q.info(`cd packages/${a}`)}
  
  To start developing (rebuilds the bundle on changes):
    ${q.info("monoreact watch")}
  
  To build the bundle:
    ${q.info("monoreact build")}
    
  To test the package:
    ${q.info("monoreact test")}
    
  ${q.highlight("Happy coding :)")}
  `},M={generating:()=>"Migrating...",successful:()=>"Migration completed successfully",failed:()=>"Failed migration detach"},N={successful:a=>`Successfully installed [${q.info(a)}] dependencies`,installing:a=>`Installing [${q.info(a)}] dependencies...`,failed:a=>`Failed to install [${q.error(a)}] dependencies`},va={linting:a=>q.info(`Linting ${a} ...`),linted:([a,c])=>q.info("Linted in ")+q.highlight(`${a}.${c.toString().slice(0,3)}s.`)},O={changeFolder:()=>"Yes, let's choose another project name",
leaveCurrentFolder:()=>"No, I want to create a project in this folder (without overwriting)",initial:a=>a,existsPrompt:a=>`The folder at ${q.error(a)} already exists! ${q.bold("Choose a different name")}`,failedPreparation:()=>q.error("A preparation error has occurred"),preparing:()=>`${q.info("Preparation in progress")}: installing dependencies, processing files`,prepared:()=>q.success("Preparation completed successfully"),creating:a=>`Creating React project at ${q.info(a)}`,failed:a=>`Failed to create ${q.error(a)} project`,
created:({name:a,dir:c})=>`${q.success("Success!")} Created new ${q.info(a)} project at ${q.info(c)}`,finish:a=>`
  ${q.success("Awesome!")} You're now ready to start coding
  
  You might begin with:
  ${q.info("cd")} ${q.bold(a)}
  ${q.info("yarn start")}
  
  ${q.info("yarn start")}
    Starts the development server
  
  ${q.info("yarn build")}
    Bundles the app into static files for production
    
  ${q.info("yarn test")}
    Starts the test runner
    
  ${q.info("yarn eject")}
    Removes this tool and copies build dependencies, configuration files and scripts into the app directory
    
  ${q.info("yarn lint")} / ${q.info("yarn stylelint")}
    Runs lint runners
    
  ${q.highlight("Happy coding :)")}
  `},P={introduce:()=>q.underline(`${w.name} v${w.version}`),watching:()=>"\nWatching for changes...",compiling:()=>`
${q.info("Compiling modules...")}`,failed:()=>q.error("Failed compilation"),compiled:a=>q.success(`${a?"Compiled":"Recompiled"} successfully.`),bundles:({source:a,module:c})=>q.info(`Bundles ${a} \u2192 ${c}`),bundled:({isFirstChange:a,duration:c,module:e})=>{const [f,h]=(c/1E3).toString().split(".");return q.success(`${a?"Created":"Updated"} ${e} in ${f}.${h.slice(0,3)}s.`)}},Q={init:()=>q.info("Initializing missing submodules"),entering:a=>q.info(`Entering '${a}'`),finished:({cmd:a,type:c,code:e})=>
q.success(`Finished ${a} '${c}' with code ${e}`)},wa={build:"Compiling",lint:"Linting",watch:"Start watching",test:"Testing"},xa={build:"Compiled",lint:"Linted",watch:"Finished watching",test:"Tested"},ya={build:"build",watch:"build",lint:"lint",test:"test"},R={introduce:()=>q.underline(`${w.name} v${w.version}`),running:a=>q.details(`Running ${a}`),started:a=>`
${q.info(`${wa[a]} modules...`)}`,finished:(a,c)=>q.success(`${xa[a]} ${c}`),failed:a=>q.error(`Failed to ${ya[a]} workspaces`),successful:([a,c])=>q.success("Done in ")+q.highlight(`${a}.${c.toString().slice(0,3)}s.`)},za=async({rootDir:a,branch:c,repoDir:e=""})=>{try{await b("git",["checkout",c],{stdio:"inherit",cwd:l.resolve(a,e)})}catch{await b("git",["checkout","-b",c],{cwd:l.resolve(a,e),stdio:"inherit"})}},Aa=async({rootDir:a,repoDir:c=""})=>{await b("git",["fetch","--all"],{cwd:l.resolve(a,
c),stdio:"inherit"})},Ba=async a=>{await b("git",["submodule","update","--remote","--init"],{cwd:a,stdio:"inherit"})},Ca=async({rootDir:a,remote:c,branch:e,repoDir:f=""})=>{await b("git",["pull",c,e],{cwd:l.resolve(a,f),stdio:"inherit"})},T=(a,c)=>a.filter(e=>!c.has(e)),Da=a=>{console.log(q.error(`Potentially circular dependency
      Please check the following packages attentively:
      ${a.map(([c,e])=>{var f;return`   ${c}  =>  ${null!=(f=null==e?void 0:e.join(", "))?f:""}`}).join("\n      ")}
      `))},U=async()=>{var a=await ra(),c=a.map(({name:h,location:g})=>[h,g]);a=await ja(a);const {chunks:e,unprocessed:f}=ka(a);c={chunks:e,packagesLocationMap:Object.fromEntries(c)};return 0<f.length&&Da(f),c},Ea={detach:{dependencies:{react:"^17.0.2","react-dom":"^17.0.2"},devDependencies:{monoreact:"latest","@typescript-eslint/parser":"^5.6.0","@types/react":"^17.0.37","@types/react-dom":"^17.0.11","eslint-config-react-app":"^6.0.0",husky:"^4.3.5","lint-staged":"^12.1.2",prettier:"^2.5.1",tslib:"^2.3.1",
typescript:"^4.5.3"}}},Fa=a=>{var c;const e=["node_modules/@types"];void 0!==a&&(a=null!=(c=a.filter(f=>!f.includes("node_modules/@types")))?c:[],e.push(...a));return e},Ga=async a=>{const c={...(await d.readJSON(l.resolve(a,"tsconfig.json")))};a=l.resolve(a,"tsconfig.json");return void 0!==c.compilerOptions&&(c.compilerOptions.typeRoots=Fa(c.compilerOptions.typeRoots)),d.outputJSON(a,c,{spaces:2})},Ha=async a=>{var c,e;const f=l.resolve(a,"package.json");a=await d.readJSON(l.resolve(a,"package.json"));
await d.outputJSON(f,{...a,dependencies:{...(null!=(c=null==a?void 0:a.dependencies)?c:{}),...Ea.detach.dependencies},devDependencies:{...(null!=(e=null==a?void 0:a.devDependencies)?e:{}),...Ea.detach.devDependencies}},{spaces:2})},V={docz:{path:".",scripts:{"start:docz":"docz dev -p 6010"}},playground:{path:"./playground",scripts:{"start:playground":'yarn build & npx concurrently --kill-others "yarn start" "cd playground & yarn start"'}}},Ia={dependencies:[],packageJson:{...fa,scripts:ca}},Ja={dependencies:Object.keys(ea.peerDependencies),
packageJson:{...fa,...ea,scripts:da}},W={basic:Ia,react:Ja},Ka=({dir:a,preset:c})=>d.outputJSON(l.resolve(a,"package.json"),c,{spaces:2}),La=async()=>{const a=aa();return null!==a?a:(new te({name:"author",message:"Who is the package author?"})).run()},Ma=({dir:a,bin:c,template:e})=>d.copy(y(c,e),a,{overwrite:!1}),X=async({basePath:a,name:c,onPromptMessage:e,onPromptInitial:f})=>{if(!d.existsSync(l.resolve(a,c)))return c;c=await (new te({message:e(c),initial:f(c),result:h=>h.trim()})).run();return X({basePath:a,
name:c,onPromptMessage:e,onPromptInitial:f})},Na=new H({message:"Choose a template",choices:Object.keys(W).map(a=>({name:a,message:q.info(a)}))}),Oa=async(a,c)=>(void 0!==a&&void 0===W[a]&&c(),void 0===a||void 0===W[a]?Na.run():a),Pa=({author:a,name:c,hostName:e,license:f,template:h})=>{const g=e.indexOf("/");e=-1===g?`@${e}`:e.slice(0,g);c=c.toLowerCase().replace(/(^@.*\/)|((^[^a-zA-Z]+)|[^\w.-])|([^a-zA-Z0-9]+$)/g,"");a={...h.packageJson,name:e?`${e}/${c}`:c,author:a};return f&&(a.license=f),a},
Qa=async({packageJson:a,packageJsonPath:c,packages:e,setupPath:f,packageName:h})=>{f=sa({packages:e,setupPath:f,packageName:h});e=a.workspaces;f=void 0===e?f:("packages"in e?e.packages=f:e=f,e);a.workspaces=f;await Be(c,a,{spaces:2})},Ra=Object.keys(W),Sa=(a,c,e=ba)=>a in V?Promise.resolve(a):(e(),(new H({message:"Choose a feature",choices:c.map(f=>({name:f,message:q.info(f)}))})).run()),Ta=(a,c)=>d.copy(y("add",c),l.resolve(a,V[c].path),{overwrite:!1,errorOnExist:!0}),Ua=({dir:a,packageJson:c,option:e})=>
d.outputJSON(a,{...c,scripts:{...c.scripts,...V[e].scripts}},{spaces:2}),Va=Object.keys(V),Wa={cra:{packageJson:ha}},Xa=a=>{const c={Yes:O.changeFolder(),No:O.leaveCurrentFolder()};return(new H({message:q.error(`Would you like to choose a different path? 
  The specified path ${q.underline(`${a}`)} is already taken.
`),choices:["Yes","No"].map(e=>({name:e,message:c[e]}))})).run()},Za=async({name:a,dir:c})=>{if(!d.existsSync(c)||"Yes"!==await Xa(c))return{projectDir:c,projectName:a};a=await Ya(a);c=l.resolve(a);return{projectName:a,projectDir:c}},Ya=async a=>X({basePath:process.cwd(),name:a,onPromptInitial:O.initial,onPromptMessage:c=>O.existsPrompt(l.resolve(c))}),$a=Object.keys(Wa),ab=({packageJson:a,runEslint:c,displayFilesize:e,useClosure:f})=>({input:a.source,output:[{file:a.module,format:"es",sourcemap:!0},
{file:a.main,format:"cjs",sourcemap:!0}],external:la(a),plugins:[qe(),Ze({clearLine:!0}),c&&Qe(),e&&Ve(),f&&Ie(),Ge(),Le(),ze(),Ke({extract:!1,modules:!0,writeDefinitions:!0,plugins:[Xe(),et(),tt({variables:{}}),st()],extensions:[".css",".scss",".sass"],use:["sass"]}),Ye({clean:!0,tsconfigDefaults:{exclude:"**/*.spec.ts **/*.test.ts **/*.spec.tsx **/*.test.tsx node_modules dist".split(" "),compilerOptions:{rootDir:"./src",sourceMap:!0,declaration:!0,jsx:"react",target:"es5",lib:["dom","dom.iterable",
"esnext"],allowJs:!0,skipLibCheck:!0,esModuleInterop:!0,allowSyntheticDefaultImports:!0,strict:!0,forceConsistentCasingInFileNames:!0,module:"esnext",moduleResolution:"node",resolveJsonModule:!0,isolatedModules:!0,noEmit:!0}}}),Re({include:/\/node_modules\//}),We({extensions:[".js",".jsx",".ts",".tsx"],preferBuiltins:!1,browser:!0}),He({babelHelpers:"runtime",skipPreflightCheck:!0,babelrc:!1,extensions:[".js","jsx",".ts",".tsx"],presets:["@babel/preset-env","@babel/preset-react"],plugins:["@babel/plugin-transform-runtime",
"@babel/proposal-class-properties"],exclude:/\/node_modules\//}),Ue({start_comment:"placeholder:start",end_comment:"placeholder:end"})]}),bb=async a=>{var c=await d.readJSON(l.resolve(a,"tsconfig.json"));a=await d.readJSON(l.resolve(a,"package.json"));await ia();const e=process.hrtime();c=ab({tsconfigJson:c,packageJson:a,displayFilesize:!0,runEslint:!1,useClosure:!1});console.log(ua.bundling(a));try{const f=await Fe(c);await Promise.all(c.output.map(g=>f.write(g)));const h=process.hrtime(e);console.log(ua.successful(h))}catch(f){A(f),
process.exit(1)}},cb=async()=>{const a=[];let c="";try{c=await I(!0),a.push(l.resolve(c,"tsconfig.json"))}catch{}try{const e=""!==c,f=await G(e);e||(c=f);a.push(l.resolve(f,"tsconfig.json"))}catch{}return{dir:c,project:a}},db=async a=>{const c=await d.readJSON(l.resolve(a,"package.json"));a=await d.readJSON(l.resolve(a,"tsconfig.json"));const e=ab({tsconfigJson:a,packageJson:c,displayFilesize:!1,runEslint:!1,useClosure:!1});let f=!0;return await ia(),new Promise(h=>{Me(e).on("event",async g=>{"BUNDLE_START"===
g.code&&(r(),console.log(P.introduce()),console.log(P.bundles(c)),console.log(P.compiling()));"ERROR"===g.code&&(console.log(P.failed()),A(g.error));"BUNDLE_END"===g.code&&(console.log(P.compiled(f)),console.log(P.bundled({isFirstChange:f,module:c.module,duration:g.duration})));"END"===g.code&&(f=!1,console.log(P.watching()),h())})})},eb=({rootDir:a,jestPackageOptions:c,jestConfigOptions:e})=>({rootDir:a,moduleFileExtensions:"ts tsx js jsx json node".split(" "),transform:{".(ts|tsx)$":require.resolve("ts-jest/dist"),
".(js|jsx)$":require.resolve("babel-jest")},transformIgnorePatterns:["[/\\\\]node_modules[/\\\\].+\\.(js|jsx)$"],testMatch:["<rootDir>/**/*.(spec|test).{ts,tsx,js,jsx}"],moduleNameMapper:{"\\.(jpg|ico|jpeg|png|gif|eot|otf|webp|svg|ttf|woff|woff2|mp4|webm|wav|mp3|m4a|aac|oga)$":"identity-obj-proxy","\\.(css|less|scss|sass)$":"identity-obj-proxy"},roots:[l.resolve(a,"src")],moduleDirectories:["node_modules","src"],testPathIgnorePatterns:[l.resolve(a,"node_modules/")],...c,...e}),fb=async(a,c)=>{try{if(c){const h=
l.resolve(a,c);process.argv.splice(process.argv.indexOf("--config"),2);const g=c.split(".");return"js"===g[g.length-1]?require(h):await d.readJSON(h)}const e=l.resolve(a,"jest.config.js"),f=l.resolve(a,"jest.config.json");if(d.existsSync(e))return require(e);if(d.existsSync(f))return await d.readJSON(f)}catch{}return{}},Y=Ce("monoreact");console.log(ta);(a=>{a.command("build").describe("Build a package.").alias("b").example("build").action(async()=>{const c=await I();await bb(c)})})(Y);
(a=>{a.command("lint").describe("Lint a package (default lint pattern src/**/*.{js,jsx,ts,tsx}.").alias("l").option("fix","Resolve fixable eslint errors").example("lint --fix").option("ignore-path","Ignore a path").example("lint --ignore-path src/foo.ts").action(async c=>{var e=process.hrtime(),f=0<c._.length?c._:["src/**/*.{js,jsx,ts,tsx}"];const {dir:h,project:g}=await cb();var m=l.resolve(h,"package.json");({eslintConfig:m={}}=await d.readJSON(m));var n=se;var p={ignorePatterns:["*.*ss"],settings:{"import/resolver":{node:{paths:[l.resolve(h,
"src")],extensions:[".js",".jsx",".ts",".tsx"]}},"import/parsers":{"@typescript-eslint/parser":[".ts",".tsx"]},react:{version:"detect"}},rules:{"import/no-unresolved":0},extends:"eslint:recommended react-app plugin:prettier/recommended plugin:react/recommended plugin:import/errors plugin:import/warnings plugin:import/typescript plugin:@typescript-eslint/recommended".split(" "),parser:"@typescript-eslint/parser",parserOptions:{tsconfigRootDir:h,project:g}};m=new n({baseConfig:{...p,...m},extensions:[".ts",
".tsx",".js",".jsx"],fix:c.fix,ignorePath:c["ignore-path"]});console.log(va.linting(f));f=await m.lintFiles(f);c.fix&&await se.outputFixes(f);c=await m.loadFormatter();console.log(c.format(f));e=process.hrtime(e);console.log(va.linted(e));for(const u of f)u.errorCount&&process.exit(1)})})(Y);(a=>{a.command("watch").describe("Rebuild a package on change.").alias("w","start").example("watch").action(async()=>{const c=await I();await db(c)})})(Y);
(a=>{a.command("test").describe("Test a package.").alias("t").option("config","Specify a path to the jest config").action(async c=>{process.env.NODE_ENV="test";process.env.BABEL_ENV="test";var e=await I(),f=l.resolve(e,"package.json");c=await fb(e,c.config);({jest:f}=await d.readJSON(f));e=eb({rootDir:e,jestPackageOptions:f,jestConfigOptions:c});ot([...process.argv.slice(3),"--config",JSON.stringify({...e})])})})(Y);
(a=>{a.command("install").describe("Install one or more dependencies to the workspace (host). \n      If you run this command inside some package, then it will be added to the package (as dev or peer dependency)").alias("i").example("install libraryName").option("dev, D","Install development dependencies").example("install libraryName --dev").action(async({_:c,dev:e})=>{const f=c.join(" "),h=D(N.installing(f));h.start();try{var g=await I(!0);const m=["add"];e?m.push("--dev"):m.push("--peer");for(const n of c)m.push(n);
await b("yarn",m,{cwd:g})}catch{}try{const m=await G(!0);g=["add","--exact","-W"];e&&g.push("--dev");"string"==typeof e&&c.push(e);for(const n of c)g.push(n);await b("yarn",g,{cwd:m});h.succeed(N.successful(f))}catch(m){h.fail(N.failed(f)),A(m),process.exit(1)}})})(Y);
(a=>{a.command("migration detach").describe("Add all necessary settings to separate the package from the workspace.").alias("mi").example("migration detach").action(async()=>{const c=D(M.generating()),e=await I();c.start();try{await Ga(e),await Ha(e),await d.copy(y("migration","detach"),e,{overwrite:!0,errorOnExist:!1}),await v("yarn install",{silent:!0}),c.succeed(M.successful())}catch(f){c.fail(M.failed()),A(f),process.exit(1)}})})(Y);
(a=>{a.command("add [featureName]").describe(`Embed ready-made feature [${Va.join(", ")}].`).example("add").example("add playground").action(async(c="")=>{const e=await Sa(c,Va,()=>console.log(K.invalidFeatureName(e)));c=await I();const f=l.resolve(c,"package.json"),h=await d.readJSON(f),g=D(K.adding(e));g.start();try{await Ta(c,e),await Ua({dir:f,packageJson:h,option:e}),g.succeed(K.successful(e))}catch(m){g.fail(K.failed(e)),m.toString().includes("already exists")&&console.log(K.exists()),A(m),
process.exit(1)}})})(Y);(a=>{a.command("generate <pkg> [path]").describe("Generate a new package.\n    Package name is required.\n    Path is optional. The path argument indicates where the folder with the package name should be generated.").alias("g").example("generate packageName").example("generate packageName .").example("generate packageName workspaces").option("t, template",`Specify a template.
     Available templates: [${Ra.join(", ")}]
     
     `).example(`generate packageName --template ${Ra[0]}`).action(async(c,e,{template:f})=>{let h=c,g=f;const m=await G(),n=l.resolve(m,"package.json"),p=await d.readJSON(n),u=D(L.generating(c));try{const x=pa(p.workspaces),J=e||qa(x);h=await X({basePath:l.resolve(m,J),name:c,onPromptMessage:Z=>L.failed(Z),onPromptInitial:Z=>L.copy(Z)});const F=l.resolve(m,J,h);g=await Oa(f,()=>{u.fail(L.invalidTemplate(f))});const S=await La();u.start();k(S);await Ma({dir:F,bin:"generate",template:g});process.chdir(F);
const gb=Pa({author:S,name:h,license:p.license,hostName:p.name,template:W[g]});await Ka({dir:F,preset:gb});await Qa({packageJsonPath:n,packageJson:p,packageName:h,packages:x,setupPath:J});u.succeed(L.successful(h))}catch(x){u.fail(L.failed(h)),A(x),process.exit(1)}({dependencies:c}=W[g]);c=D(L.preparingPackage(h,c.sort())).start();try{await v("npx sort-package-json",{silent:!0});const x=await v("yarn build",{silent:!0});if(0<x.code)throw Error(x.stderr);c.succeed(L.successfulConfigure());console.log(L.preparedPackage(h))}catch(x){c.fail(L.failedConfigure()),
A(x),process.exit(1)}})})(Y);(a=>{a.command("new <name> [dir]").describe("Create a new React project (scaffolding).\n    Project name is required.\n    Directory is optional. However, if you specify dir, then template files will be installed there, even if this folder already exists, but without overwriting.").example("new projectName").example("new projectName .").example("new projectName projectDirectory").option("t, template",`Specify a template.
     Available templates: [${$a.join(", ")}]
     
     `,"cra").example(`new projectName --template ${$a[0]}`).option("f, force","Skip folder checks",!1).action(async(c,e,{template:f,force:h})=>{const g=D();e=l.resolve(e||c);const {projectDir:m,projectName:n}=h?{projectDir:e,projectName:c}:await Za({name:c,dir:e});g.start(O.creating(m));try{await Ma({dir:m,bin:"new",template:f});g.stop();const p=await La();k(p);g.start();process.chdir(m);await Ka({dir:m,preset:{...Wa[f].packageJson,name:n,author:p}});g.succeed(O.created({dir:m,name:n}))}catch(p){g.fail(O.failed(n)),
A(p),process.exit(1)}c=D(O.preparing()).start();try{v("npx sort-package-json",{silent:!0}),v("yarn install",{silent:!0}),c.succeed(O.prepared())}catch(p){c.fail(O.failedPreparation()),A(p)}console.log(O.finish(m))})})(Y);
(function(a){a.command("submodules checkout <branch>").describe("Checkout all submodules on the specific branch.").example("submodules checkout branch-name").alias("sc").option("s, self","Apply checkout for the host workspace").example("submodules checkout branch-name --self").action(async(c,{self:e})=>{let f=await G(),h=await C();for(let g of h)console.log(Q.entering(g)),await za({rootDir:f,repoDir:g,branch:c}),process.stdout.write("\n");e&&(console.log(Q.entering("host")),await za({rootDir:f,branch:c}),
process.stdout.write("\n"))})})(Y);(function(a){a.command("submodules fetch").describe("Fetch all submodules.").example("submodules fetch").alias("sf").option("s, self","Apply fetch for the host workspace").example("submodules fetch --self").action(async({self:c})=>{let e=await G(),f=await C();for(let h of f)console.log(Q.entering(h)),await Aa({rootDir:e,repoDir:h}),process.stdout.write("\n");c&&(console.log(Q.entering("host")),await Aa({rootDir:e}),process.stdout.write("\n"))})})(Y);
(function(a){a.command("submodules init").describe("Initialize missed submodules.").example("submodules init").alias("si").action(async()=>{let c=await G();console.log(Q.init());process.stdout.write("\n");await Ba(c)})})(Y);
(function(a){a.command("submodules pull [branch]").describe("Pull all submodules (default: master).").example("submodules pull").example("submodules pull develop").alias("sp").option("r, remote","Define git remote","origin").example("submodules pull master --remote fork").option("s, self","Apply pull for the host workspace").example("submodules pull --self").action(async(c="master",{self:e,remote:f})=>{let h=await G(),g=await C();for(let m of g)console.log(Q.entering(m)),await Ca({rootDir:h,repoDir:m,
remote:f,branch:c}),process.stdout.write("\n");e&&(console.log(Q.entering("host")),await Ca({rootDir:h,remote:f,branch:c}),process.stdout.write("\n"))})})(Y);
(function(a){a.command("workspaces build").describe("Build all workspaces.").example("workspaces build").alias("wb").option("q, quiet","Do not print logs",!1).example("workspaces build --quiet").option("e, exclude","Exclude specific workspaces").example("workspaces build --exclude  workspace1,workspace2,workspace3").action(async({quiet:c,exclude:e})=>{let {chunks:f,packagesLocationMap:h}=await U();e=t(e);e.set(w.name,!0);r();console.log(R.introduce());console.log(R.started("build"));c||process.stdout.write("\n");
try{let g=process.hrtime();for(let n of f)await Promise.all(T(n,e).map(async p=>{c||console.log(R.running(p));let {stderr:u,exitCode:x,failed:J}=await b("node",[l.resolve(__dirname,"../"),"build"],{cwd:h[p]});if(!c){let F=""!==u&&void 0!==u?u:"Unknown error";if(0!==x||J)throw Error(F);console.log(R.finished("build",p))}}));c||process.stdout.write("\n");let m=process.hrtime(g);console.log(R.successful(m));process.stdout.write("\n")}catch(g){console.log(R.failed("build")),A(g),process.exit(1)}})})(Y);
(function(a){a.command("workspaces lint").describe("Lint all workspaces.").example("workspaces lint").alias("wl").option("fix","Resolve fixable eslint errors",!1).example("workspaces lint --fix").option("exclude","Exclude specific workspaces","").example("workspaces lint --exclude workspace1,workspace2,workspace3").action(async({exclude:c,fix:e})=>{let {chunks:f,packagesLocationMap:h}=await U();c=t(c);c.set(w.name,!0);let g=[l.resolve(__dirname,".."),"lint","src/**/*.{js,jsx,ts,tsx}"];e&&g.push("--fix");
r();console.log(R.introduce());console.log(R.started("lint"));try{process.stdout.write("\n");let m=process.hrtime();for(let p of f)for(let u of T(p,c)){process.stdout.write("\n");console.log(R.running(u));try{await b("node",g,{cwd:h[u],stdio:"inherit"})}catch(x){A(x)}console.log(R.finished("lint",u))}let n=process.hrtime(m);console.log(R.successful(n));process.stdout.write("\n")}catch(m){console.log(R.failed("lint")),A(m),process.exit(1)}})})(Y);
(function(a){a.command("workspaces watch").describe("Watch all workspaces.").example("workspaces watch").alias("workspaces start","ws").option("q, quiet","Do not print logs",!1).example("workspaces watch --quiet").option("exclude","Exclude specific workspaces").example("workspaces watch --exclude  workspace1,workspace2,workspace3").action(async({quiet:c,exclude:e})=>{let {chunks:f,packagesLocationMap:h}=await U();e=t(e);e.set(w.name,!0);r();console.log(R.introduce());console.log(R.started("watch"));
c||process.stdout.write("\n");try{let g=process.hrtime();for(let n of f)await Promise.all(T(n,e).map(async p=>{var u;c||console.log(R.running(p));let x=b("node",[l.resolve(__dirname,".."),"watch","--color"],{cwd:h[p],stderr:process.stderr});null==(u=x.stdout)||u.pipe(process.stdout);await new Promise(J=>{var F;null==(F=x.stdout)||F.on("data",S=>{S.toString().includes(P.compiled(!0))&&J()})})}));c||process.stdout.write("\n");r();let m=process.hrtime(g);console.log(R.successful(m));process.stdout.write("\n")}catch(g){console.log(R.failed("watch")),
A(g)}})})(Y);
(function(a){a.command("workspaces test").describe("Test all workspaces.").example("workspaces test").alias("wt").option("exclude","Exclude specific workspaces","").example("workspaces test --exclude workspace1,workspace2,workspace3").action(async({exclude:c})=>{let {chunks:e,packagesLocationMap:f}=await U();c=t(c);c.set(w.name,!0);r();console.log(R.introduce());console.log(R.started("test"));try{process.stdout.write("\n");let h=process.hrtime();for(let m of e)for(let n of T(m,c))process.stdout.write("\n"),console.log(R.running(n)),
await b("node",[l.resolve(__dirname,".."),"test","--passWithNoTests"],{cwd:f[n],stdio:"inherit"}),console.log(R.finished("test",n));process.stdout.write("\n");let g=process.hrtime(h);console.log(R.successful(g));process.stdout.write("\n")}catch(h){console.log(R.failed("test")),A(h),process.exit(1)}})})(Y);Y.version(w.version).parse(process.argv)
