#!/usr/bin/env node
import{run as at}from'jest';import{ESLint as oe}from'eslint';import nt from'postcss-nested';import ot from'postcss-simple-vars';import st from'cssnano';import tt from'autoprefixer';import{eslint as et}from'rollup-plugin-eslint';import Xe from'rollup-plugin-progress';import Qe from'rollup-plugin-filesize';import Ze from'rollup-plugin-strip-code';import Ve from'rollup-plugin-postcss';import Ue from'rollup-plugin-typescript2';import Ke from'@rollup/plugin-babel';import Ye from'@rollup/plugin-beep';import He from'@rollup/plugin-json';import qe from'@rollup/plugin-image';import Ge from'@rollup/plugin-url';import ze from'@rollup/plugin-node-resolve';import Le from'@rollup/plugin-commonjs';import We from'@ampproject/rollup-plugin-closure-compiler';import{rollup as Be,watch as Re}from'rollup';import{Input as se,Select as H}from'enquirer';import D from'ora';import b from'execa';import l from'path';import d,{outputJSON as Ie}from'fs-extra';import{bold as E,yellow as Je,cyan as Ee,blue as Te,red as _e,green as Ae,inverse as Fe,underline as Me}from'colorette';import{always as Oe,pipe as F}from'ramda';import De,{exec as x}from'shelljs';import Ne from'sade';((N,J)=>()=>(J||N((J={exports:{}}).exports,J),J.exports))(()=>{function N(a){x(`npm config set init-author-name "${a}"`,{silent:!0})}function J(){var a=x("npm config get init-author-name",{silent:!0}).stdout.trim();return a?a:(a=x("git config user.name",{silent:!0}).stdout.trim())?(N(a),a):(a=x("npm config get init-author-email",{silent:!0}).stdout.trim())?a:x("git config user.email",{silent:!0}).stdout.trim()||null}function K(){process.stdout.write("win32"===process.platform?"\u001b[2J\u001b[0f":
"\u001b[2J\u001b[3J\u001b[H")}function u(a){a=a.error||a;var c=a.name?`${a.name} `:"";let e=a.message||a;c=c?`${c} ${e}`:e;c=a.plugin?"rpt2"===a.plugin?`(typescript) ${c}`:`(${a.plugin} plugin) ${c}`:c;process.stdout.write("\n");a.stack?P(k.error(a.stack)):(P(k.error(c)),a.loc&&P(`at ${a.loc.file}:${a.loc.line}:${a.loc.column}`),process.stdout.write("\n"),a.frame&&P(k.error(a.frame)));process.stdout.write("\n")}async function ta(){let a=await z(),c=x("yarn workspaces --json info",{cwd:a,silent:!0}).stdout.trim(),
e=JSON.parse(JSON.parse(c).data);return Object.keys(e).reduce((f,h)=>[...f,{name:h,location:l.resolve(a,e[h].location)}],[])}function ua(a){a.command("submodules checkout <branch>").describe("Checkout all submodules on the specific branch.").example("submodules checkout branch-name").alias("sc").option("s, self","Apply checkout for the host workspace").example("submodules checkout branch-name --self").action(async(c,{self:e})=>{let f=await z(),h=await V();for(let g of h)console.log(C.entering(g)),
await ba({rootDir:f,repoDir:g,branch:c}),process.stdout.write("\n");e&&(console.log(C.entering("host")),await ba({rootDir:f,branch:c}),process.stdout.write("\n"))})}function va(a){a.command("submodules fetch").describe("Fetch all submodules.").example("submodules fetch").alias("sf").option("s, self","Apply fetch for the host workspace").example("submodules fetch --self").action(async({self:c})=>{let e=await z(),f=await V();for(let h of f)console.log(C.entering(h)),await ca({rootDir:e,repoDir:h}),
process.stdout.write("\n");c&&(console.log(C.entering("host")),await ca({rootDir:e}),process.stdout.write("\n"))})}function wa(a){a.command("submodules init").describe("Initialize missed submodules.").example("submodules init").alias("si").action(async()=>{let c=await z();console.log(C.init());process.stdout.write("\n");await xa(c)})}function ya(a){a.command("submodules pull [branch]").describe("Pull all submodules (default: master).").example("submodules pull").example("submodules pull develop").alias("sp").option("r, remote",
"Define git remote","origin").example("submodules pull master --remote fork").option("s, self","Apply pull for the host workspace").example("submodules pull --self").action(async(c="master",{self:e,remote:f})=>{let h=await z(),g=await V();for(let m of g)console.log(C.entering(m)),await da({rootDir:h,repoDir:m,remote:f,branch:c}),process.stdout.write("\n");e&&(console.log(C.entering("host")),await da({rootDir:h,remote:f,branch:c}),process.stdout.write("\n"))})}function za(a){a.command("workspaces build").describe("Build all workspaces.").example("workspaces build").alias("wb").option("q, quiet",
"Do not print logs",!1).example("workspaces build --quiet").option("e, exclude","Exclude specific workspaces").example("workspaces build --exclude  workspace1,workspace2,workspace3").action(async({quiet:c,exclude:e})=>{let {chunks:f,packagesLocationMap:h}=await Q();e=R(e);e.set(r.name,!0);K();console.log(q.introduce());console.log(q.started("build"));c||process.stdout.write("\n");try{let g=process.hrtime();for(let n of f)await Promise.all(S(n,e).map(async p=>{c||console.log(q.running(p));let {stderr:t,
exitCode:v,failed:G}=await b("node",[l.resolve(__dirname,"../"),"build"],{cwd:h[p]});if(!c){let A=""!==t&&void 0!==t?t:"Unknown error";if(0!==v||G)throw Error(A);console.log(q.finished("build",p))}}));c||process.stdout.write("\n");let m=process.hrtime(g);console.log(q.successful(m));process.stdout.write("\n")}catch(g){console.log(q.failed("build")),u(g),process.exit(1)}})}function Aa(a){a.command("workspaces test").describe("Test all workspaces.").example("workspaces test").alias("wt").option("exclude",
"Exclude specific workspaces","").example("workspaces test --exclude workspace1,workspace2,workspace3").action(async({exclude:c})=>{let {chunks:e,packagesLocationMap:f}=await Q();c=R(c);c.set(r.name,!0);K();console.log(q.introduce());console.log(q.started("test"));try{process.stdout.write("\n");let h=process.hrtime();for(let m of e)for(let n of S(m,c))process.stdout.write("\n"),console.log(q.running(n)),await b("node",[l.resolve(__dirname,".."),"test","--passWithNoTests"],{cwd:f[n],stdio:"inherit"}),
console.log(q.finished("test",n));process.stdout.write("\n");let g=process.hrtime(h);console.log(q.successful(g));process.stdout.write("\n")}catch(h){console.log(q.failed("test")),u(h),process.exit(1)}})}function Ba(a){a.command("workspaces lint").describe("Lint all workspaces.").example("workspaces lint").alias("wl").option("fix","Resolve fixable eslint errors",!1).example("workspaces lint --fix").option("exclude","Exclude specific workspaces","").example("workspaces lint --exclude workspace1,workspace2,workspace3").action(async({exclude:c,
fix:e})=>{let {chunks:f,packagesLocationMap:h}=await Q();c=R(c);c.set(r.name,!0);let g=[l.resolve(__dirname,".."),"lint","src/**/*.{js,jsx,ts,tsx}"];e&&g.push("--fix");K();console.log(q.introduce());console.log(q.started("lint"));try{process.stdout.write("\n");let m=process.hrtime();for(let p of f)for(let t of S(p,c)){process.stdout.write("\n");console.log(q.running(t));try{await b("node",g,{cwd:h[t],stdio:"inherit"})}catch(v){u(v)}console.log(q.finished("lint",t))}let n=process.hrtime(m);console.log(q.successful(n));
process.stdout.write("\n")}catch(m){console.log(q.failed("lint")),u(m),process.exit(1)}})}function Ca(a){a.command("workspaces watch").describe("Watch all workspaces.").example("workspaces watch").alias("workspaces start","ws").option("q, quiet","Do not print logs",!1).example("workspaces watch --quiet").option("exclude","Exclude specific workspaces").example("workspaces watch --exclude  workspace1,workspace2,workspace3").action(async({quiet:c,exclude:e})=>{let {chunks:f,packagesLocationMap:h}=await Q();
e=R(e);e.set(r.name,!0);K();console.log(q.introduce());console.log(q.started("watch"));c||process.stdout.write("\n");try{let g=process.hrtime();for(let n of f)await Promise.all(S(n,e).map(async p=>{var t;c||console.log(q.running(p));let v=b("node",[l.resolve(__dirname,".."),"watch","--color"],{cwd:h[p],stderr:process.stderr});null==(t=v.stdout)||t.pipe(process.stdout);await new Promise(G=>{var A;null==(A=v.stdout)||A.on("data",T=>{T.toString().includes(B.compiled(!0))&&G()})})}));c||process.stdout.write("\n");
K();let m=process.hrtime(g);console.log(q.successful(m));process.stdout.write("\n")}catch(g){console.log(q.failed("watch")),u(g)}})}let Da=Oe(void 0),k={info:a=>F(E,Ee)(a),details:a=>F(E,Te)(a),error:a=>F(E,_e)(a),success:a=>F(E,Ae)(a),highlight:a=>F(E,Je)(a),bold:a=>E(a),inverse:a=>Fe(a),underline:a=>Me(a)},R=(a="")=>{let c="";for(let e=0;e<a.length;e+=1)" "!==a[e]&&(c+=a[e]);return""===c?new Map:new Map(c.split(",").map(e=>[e,!0]))};var r={name:"monoreact",version:"0.31.0",description:"React workspaces implementation",
license:"MIT",main:"./dist/bundle.cjs",module:"./dist/bundle.mjs",next:"./dist/bundle.mjs",bin:{monoreact:"./dist/bundle.mjs"},author:{email:"tarsis.maksym@gmail.com",name:"Maksym Tarsis",url:"https://github.com/untaggable"},repository:{type:"git",url:"https://github.com/untaggable/monoreact.git"},homepage:"https://github.com/untaggable/monoreact#readme",bugs:"https://github.com/untaggable/monoreact/issues",scripts:{start:"yarn build -w",build:"rollup -c rollup.config.js",lint:'eslint "src/**/*.{js,jsx,ts,tsx}"',
test:"jest",prepublishOnly:"yarn build && yarn test"},dependencies:{"@ampproject/rollup-plugin-closure-compiler":"0.27.0","@babel/cli":"7.16.7","@babel/core":"7.16.7","@babel/plugin-proposal-class-properties":"7.16.7","@babel/plugin-transform-runtime":"7.16.7","@babel/preset-env":"7.16.7","@babel/preset-react":"7.16.7","@babel/runtime":"7.16.7","@rollup/plugin-babel":"5.3.0","@rollup/plugin-beep":"0.2.0","@rollup/plugin-commonjs":"21.0.1","@rollup/plugin-image":"2.1.1","@rollup/plugin-json":"4.1.0",
"@rollup/plugin-node-resolve":"13.1.2","@rollup/plugin-url":"6.1.0","@typescript-eslint/eslint-plugin":"5.8.1","@typescript-eslint/parser":"5.8.1",autoprefixer:"10.4.1","babel-jest":"27.4.5",colorette:"2.0.16",cssnano:"5.0.14",enquirer:"2.3.6",eslint:"8.6.0","eslint-config-prettier":"8.3.0","eslint-config-react-app":"6.0.0","eslint-import-resolver-typescript":"2.5.0","eslint-plugin-compat":"4.0.0","eslint-plugin-flowtype":"8.0.3","eslint-plugin-import":"2.25.3","eslint-plugin-jsx-a11y":"6.5.1","eslint-plugin-prettier":"4.0.0",
"eslint-plugin-react":"7.28.0","eslint-plugin-react-hooks":"4.3.0",execa:"6.0.0","fs-extra":"10.0.0","identity-obj-proxy":"3.0.0",jest:"27.4.5","node-sass":"7.0.1",ora:"5.4.1",postcss:"8.4.5","postcss-nested":"5.0.6","postcss-simple-vars":"6.0.3",ramda:"0.27.1",react:"17.0.2","react-dom":"17.0.2",rollup:"2.62.0","rollup-plugin-analyzer":"4.0.0","rollup-plugin-eslint":"7.0.0","rollup-plugin-filesize":"9.1.1","rollup-plugin-postcss":"4.0.2","rollup-plugin-progress":"1.1.2","rollup-plugin-size-snapshot":"0.12.0",
"rollup-plugin-strip-code":"0.2.7","rollup-plugin-typescript2":"0.31.1","rollup-plugin-visualizer":"5.5.2",sade:"1.8.0",shelljs:"0.8.4","ts-jest":"27.1.2",tslib:"2.3.1",typescript:"4.5.4"},devDependencies:{"@types/eslint":"8.2.1","@types/fs-extra":"9.0.13","@types/jest":"27.4.0","@types/node":"16.11.17","@types/ramda":"0.27.62","@types/react":"17.0.38","@types/sade":"1.7.4","@types/shelljs":"0.8.10",esbuild:"0.14.10","rollup-plugin-esbuild":"4.8.2","rollup-plugin-node-builtins":"2.1.2","rollup-plugin-node-globals":"1.4.0",
"rollup-plugin-preserve-shebangs":"0.2.0",yarn:"1.22.17"},publishConfig:{access:"public"},workspace:!0,keywords:"cli microfrontend workspaces submodules monorepo react typescript rollup".split(" ")};let ea={start:"npx monoreact watch",build:"npx monoreact build",test:"npx monoreact test --passWithNoTests",lint:'npx monoreact lint "src/**/*.{js,jsx,ts,tsx}"',prepublishOnly:"yarn build"},Ea={...ea,stylelint:'npx stylelint "src/**/*.{css,sass,scss}"'},fa={peerDependencies:{react:"*"}},ha={name:void 0,
author:void 0,workspace:!0,private:!1,version:"0.1.0",main:"dist/bundle.cjs.js",module:"dist/bundle.js",types:"dist/publicApi.d.ts",source:"src/publicApi.ts",publishConfig:{access:"public"}},Fa={name:void 0,author:void 0,version:"0.1.0",private:!0,license:"MIT",workspaces:[],scripts:{start:"react-scripts start",build:"react-scripts build",test:"react-scripts test",eject:"react-scripts eject",lint:"monoreact lint",stylelint:'stylelint "src/**/*.{css,sass,scss}"'},dependencies:{react:"^17.0.2","react-dom":"^17.0.2",
"react-scripts":"5.0.0"},devDependencies:{monoreact:"latest","@testing-library/jest-dom":"^5.16.1","@testing-library/react":"^12.1.2","@testing-library/user-event":"^13.5.0","web-vitals":"^2.1.2","@types/jest":"^27.0.3","@types/react":"^17.0.37","@types/react-dom":"^17.0.11","@types/node":r.devDependencies["@types/node"],"@typescript-eslint/eslint-plugin":"5.7.0","@typescript-eslint/parser":"5.7.0","eslint-config-prettier":r.dependencies["eslint-config-prettier"],"eslint-config-react-app":r.dependencies["eslint-config-react-app"],
"eslint-plugin-prettier":r.dependencies["eslint-plugin-prettier"],"eslint-plugin-promise":"5.2.0","eslint-plugin-react":r.dependencies["eslint-plugin-react"],"eslint-plugin-react-hooks":r.dependencies["eslint-plugin-react-hooks"],"eslint-plugin-import":r.dependencies["eslint-plugin-import"],"eslint-plugin-sonarjs":"0.11.0","eslint-plugin-jsx-a11y":r.dependencies["eslint-plugin-jsx-a11y"],husky:"4.3.8","lint-staged":"12.1.2",prettier:"2.5.1",stylelint:"14.1.0","stylelint-config-recommended":"3.0.0",
tslib:r.dependencies.tslib,typescript:r.dependencies.typescript,yarn:r.devDependencies.yarn},browserslist:{production:[">0.2%","not dead","not op_mini all"],development:["last 1 chrome version","last 1 firefox version","last 1 safari version"]}},ia=async()=>{var a=process.cwd();a=l.resolve(a,"dist");await d.remove(a)},W=(...a)=>l.resolve(__dirname,"../templates",...a),Ga=async a=>{a=a.map(c=>d.readJSON(l.resolve(c.location,"package.json")));return(await Promise.allSettled(a)).map(c=>c.value)},Ha=
a=>{const c=[],e=Object.fromEntries(a.map(({name:h,dependencies:g={},devDependencies:m={},peerDependencies:n={}})=>[h,{...g,...m,...n}])),f=new Map;for(const h in e)f.set(h,Object.keys(e[h]).filter(g=>void 0!==e[g]));for(a=Array.from(f.keys()).reduce((h,g)=>0<f.get(g).length?h:[...h,g],[]);0<a.length;){c.push(a);for(const h of a)f.delete(h);a=Array.from(f.keys()).filter(h=>{var g,m;const n=null!=(m=null==(g=f.get(h))?void 0:g.filter(p=>f.has(p)))?m:[];return f.set(h,n),0===n.length})}return{chunks:c,
unprocessed:Array.from(f.entries())}},Ia=({dependencies:a={},peerDependencies:c={},devDependencies:e={}})=>{const f=[...Object.keys(a),...Object.keys(c),...Object.keys(e)],h=new Map(f.map(g=>[g,g]));return g=>h.has(g)||!!f.find(m=>g.startsWith(`${m}/`))},P=console.error.bind(console),V=async()=>{var a=x("git submodule foreach --quiet 'echo $name'",{silent:!0});({stdout:a}=a);return a.trim().split("\n")};De.config.silent=!0;let Ja=process.cwd();l.join(Ja,"test",".staging");class Ka extends Error{constructor(){super("\n    \n    Can't find workspace\n    Make sure you run the script inside the project\n      ");
this.isNotFoundHostError=!0;this.name="Not Found Workspace Error"}}class La extends Error{constructor(){super("\n    \n    Can't find workspace package\n    Make sure you run the script inside the package\n        \n    The workspace package.json should have:\n        workspace: true;\n        private: false;\n      ");this.isNotFoundPackageError=!0;this.name="Not Found Workspace Error"}}let Ma=a=>{var c;return void 0===a?[]:"packages"in a?null!=(c=a.packages)?c:[]:a},Na=a=>{if(0===a.length)return"packages";
const c=a.find(e=>"*"===e[e.length-1]);return void 0!==c?c.slice(0,c.length-2):a[0].split("/").filter(Boolean).slice(0,-1).join("/")},Oa=({packages:a,packageName:c,setupPath:e})=>{e=e.split("/").filter(f=>"."!==f&&""!==f).join("/");c=""===e?c:`${e}/${c}`;e=""===e?"*":`${e}/*`;for(const f of a)if(f===e||f===c)return a;return a.concat(c)},z=async(a=!1)=>{async function c(f){if(10>f.length)return null;var h=l.resolve(f,"package.json"),g;if(g=d.existsSync(h))h=await d.readJSON(h),g=void 0!==h.workspaces&&
h.private;return g?f:c(l.resolve(f,".."))}var e=await c(await d.realpath(process.cwd()));if(null!==e)return e;e=new Ka;if(a)throw e;u(e);process.exit(1)},I=async(a=!1)=>{async function c(f){var h=l.resolve(f,"package.json"),g={};d.existsSync(h)&&(g=await d.readJSON(h));h=10>f.length;const m=void 0!==g.workspaces&&g.private;g=g.workspace&&!g.private;switch(!0){case h||m:return null;case g:return f;default:return c(l.resolve(f,".."))}}var e=await c(await d.realpath(process.cwd()));if(null!==e)return e;
e=new La;if(a)throw e;u(e);process.exit(1)},Pa=k.highlight("\n  M O N O R E A C T\n    "),O={exists:()=>k.error("\n    It seems like you already have this feature.\n        "),invalidFeatureName:a=>{a=k.inverse(` ${a} `);return k.error(`
  Invalid feature name
  Unfortunately, monoreact doesn't provide ${a} feature
        `)},adding:a=>`Adding ${k.info(a)} feature...`,successful:a=>`Added ${k.success(a)} feature template`,failed:a=>`Failed to add ${k.error(a)} feature template`},ja={bundling:({source:a,module:c})=>k.info(`${a} \u2192 ${c}`),successful:([a,c])=>k.success("Compiled in ")+k.highlight(`${a}.${c.toString().slice(0,3)}s.`)},y={copy:a=>`${a}-copy`,successful:a=>`Generated ${k.info(a)} package`,generating:a=>`Generating ${k.info(a)} package...`,failed:a=>`Failed to generate ${k.error(a)} package`,
successfulConfigure:()=>"The package successfully configured",failedConfigure:()=>"Failed to fully configure the package",invalidTemplate:a=>`Invalid template ${k.error(a)}`,exists:a=>`A folder named ${k.error(a)} already exists! ${k.bold("Choose a different name")}`,preparingPackage:(a,c)=>{const e=c.map(f=>`     ${k.info(f)}`).join("\n");a=`Preparing ${k.info(a)} package`;return 0<c.length?`${a} with the following peer dependencies: 
${e}
`:a},preparedPackage:a=>`
  ${k.success("Awesome!")} You're now ready to start coding.
  
  There is no need to run ${k.info("monoreact install")}, since all peer dependencies are already in the workspace root
  
  So your next steps are:
    ${k.info(`cd packages/${a}`)}
  
  To start developing (rebuilds the bundle on changes):
    ${k.info("monoreact watch")}
  
  To build the bundle:
    ${k.info("monoreact build")}
    
  To test the package:
    ${k.info("monoreact test")}
    
  ${k.highlight("Happy coding :)")}
  `},X={generating:()=>"Migrating...",successful:()=>"Migration completed successfully",failed:()=>"Failed migration detach"},Y={successful:a=>`Successfully installed [${k.info(a)}] dependencies`,installing:a=>`Installing [${k.info(a)}] dependencies...`,failed:a=>`Failed to install [${k.error(a)}] dependencies`},ka={linting:a=>k.info(`Linting ${a} ...`),linted:([a,c])=>k.info("Linted in ")+k.highlight(`${a}.${c.toString().slice(0,3)}s.`)},w={changeFolder:()=>"Yes, let's choose another project name",
leaveCurrentFolder:()=>"No, I want to create a project in this folder (without overwriting)",initial:a=>a,existsPrompt:a=>`The folder at ${k.error(a)} already exists! ${k.bold("Choose a different name")}`,failedPreparation:()=>k.error("A preparation error has occurred"),preparing:()=>`${k.info("Preparation in progress")}: installing dependencies, processing files`,prepared:()=>k.success("Preparation completed successfully"),creating:a=>`Creating React project at ${k.info(a)}`,failed:a=>`Failed to create ${k.error(a)} project`,
created:({name:a,dir:c})=>`${k.success("Success!")} Created new ${k.info(a)} project at ${k.info(c)}`,finish:a=>`
  ${k.success("Awesome!")} You're now ready to start coding
  
  You might begin with:
  ${k.info("cd")} ${k.bold(a)}
  ${k.info("yarn start")}
  
  ${k.info("yarn start")}
    Starts the development server
  
  ${k.info("yarn build")}
    Bundles the app into static files for production
    
  ${k.info("yarn test")}
    Starts the test runner
    
  ${k.info("yarn eject")}
    Removes this tool and copies build dependencies, configuration files and scripts into the app directory
    
  ${k.info("yarn lint")} / ${k.info("yarn stylelint")}
    Runs lint runners
    
  ${k.highlight("Happy coding :)")}
  `},B={introduce:()=>k.underline(`${r.name} v${r.version}`),watching:()=>"\nWatching for changes...",compiling:()=>`
${k.info("Compiling modules...")}`,failed:()=>k.error("Failed compilation"),compiled:a=>k.success(`${a?"Compiled":"Recompiled"} successfully.`),bundles:({source:a,module:c})=>k.info(`Bundles ${a} \u2192 ${c}`),bundled:({isFirstChange:a,duration:c,module:e})=>{const [f,h]=(c/1E3).toString().split(".");return k.success(`${a?"Created":"Updated"} ${e} in ${f}.${h.slice(0,3)}s.`)}},C={init:()=>k.info("Initializing missing submodules"),entering:a=>k.info(`Entering '${a}'`),finished:({cmd:a,type:c,code:e})=>
k.success(`Finished ${a} '${c}' with code ${e}`)},Qa={build:"Compiling",lint:"Linting",watch:"Start watching",test:"Testing"},Ra={build:"Compiled",lint:"Linted",watch:"Finished watching",test:"Tested"},Sa={build:"build",watch:"build",lint:"lint",test:"test"},q={introduce:()=>k.underline(`${r.name} v${r.version}`),running:a=>k.details(`Running ${a}`),started:a=>`
${k.info(`${Qa[a]} modules...`)}`,finished:(a,c)=>k.success(`${Ra[a]} ${c}`),failed:a=>k.error(`Failed to ${Sa[a]} workspaces`),successful:([a,c])=>k.success("Done in ")+k.highlight(`${a}.${c.toString().slice(0,3)}s.`)},ba=async({rootDir:a,branch:c,repoDir:e=""})=>{try{await b("git",["checkout",c],{stdio:"inherit",cwd:l.resolve(a,e)})}catch{await b("git",["checkout","-b",c],{cwd:l.resolve(a,e),stdio:"inherit"})}},ca=async({rootDir:a,repoDir:c=""})=>{await b("git",["fetch","--all"],{cwd:l.resolve(a,
c),stdio:"inherit"})},xa=async a=>{await b("git",["submodule","update","--remote","--init"],{cwd:a,stdio:"inherit"})},da=async({rootDir:a,remote:c,branch:e,repoDir:f=""})=>{await b("git",["pull",c,e],{cwd:l.resolve(a,f),stdio:"inherit"})},S=(a,c)=>a.filter(e=>!c.has(e)),Ta=a=>{console.log(k.error(`Potentially circular dependency
      Please check the following packages attentively:
      ${a.map(([c,e])=>{var f;return`   ${c}  =>  ${null!=(f=null==e?void 0:e.join(", "))?f:""}`}).join("\n      ")}
      `))},Q=async()=>{var a=await ta(),c=a.map(({name:h,location:g})=>[h,g]);a=await Ga(a);const {chunks:e,unprocessed:f}=Ha(a);c={chunks:e,packagesLocationMap:Object.fromEntries(c)};return 0<f.length&&Ta(f),c};var Ua={react:"^17.0.2","react-dom":"^17.0.2"},Va={monoreact:"latest","@typescript-eslint/parser":"^5.6.0","@types/react":"^17.0.37","@types/react-dom":"^17.0.11","eslint-config-react-app":"^6.0.0",husky:"^4.3.5","lint-staged":"^12.1.2",prettier:"^2.5.1",tslib:"^2.3.1",typescript:"^4.5.3"};
let Wa=a=>{var c;const e=["node_modules/@types"];void 0!==a&&(a=null!=(c=a.filter(f=>!f.includes("node_modules/@types")))?c:[],e.push(...a));return e},Xa=async a=>{const c={...(await d.readJSON(l.resolve(a,"tsconfig.json")))};a=l.resolve(a,"tsconfig.json");return void 0!==c.compilerOptions&&(c.compilerOptions.typeRoots=Wa(c.compilerOptions.typeRoots)),d.outputJSON(a,c,{spaces:2})},Ya=async a=>{var c,e;const f=l.resolve(a,"package.json");a=await d.readJSON(l.resolve(a,"package.json"));await d.outputJSON(f,
{...a,dependencies:{...(null!=(c=null==a?void 0:a.dependencies)?c:{}),...Ua},devDependencies:{...(null!=(e=null==a?void 0:a.devDependencies)?e:{}),...Va}},{spaces:2})},U={docz:{path:".",scripts:{"start:docz":"docz dev -p 6010"}},playground:{path:"./playground",scripts:{"start:playground":'yarn build & npx concurrently --kill-others "yarn start" "cd playground & yarn start"'}}},Za={dependencies:[],packageJson:{...ha,scripts:ea}},$a={dependencies:Object.keys(fa.peerDependencies),packageJson:{...ha,
...fa,scripts:Ea}},L={basic:Za,react:$a},la=({dir:a,preset:c})=>d.outputJSON(l.resolve(a,"package.json"),c,{spaces:2}),ma=async()=>{const a=J();return null!==a?a:(new se({name:"author",message:"Who is the package author?"})).run()},na=({dir:a,bin:c,template:e})=>d.copy(W(c,e),a,{overwrite:!1}),Z=async({basePath:a,name:c,onPromptMessage:e,onPromptInitial:f})=>{if(!d.existsSync(l.resolve(a,c)))return c;c=await (new se({message:e(c),initial:f(c),result:h=>h.trim()})).run();return Z({basePath:a,name:c,
onPromptMessage:e,onPromptInitial:f})},ab=new H({message:"Choose a template",choices:Object.keys(L).map(a=>({name:a,message:k.info(a)}))}),bb=async(a,c)=>(void 0!==a&&void 0===L[a]&&c(),void 0===a||void 0===L[a]?ab.run():a),cb=({author:a,name:c,hostName:e,license:f,template:h})=>{const g=e.indexOf("/");e=-1===g?`@${e}`:e.slice(0,g);c=c.toLowerCase().replace(/(^@.*\/)|((^[^a-zA-Z]+)|[^\w.-])|([^a-zA-Z0-9]+$)/g,"");a={...h.packageJson,name:e?`${e}/${c}`:c,author:a};return f&&(a.license=f),a},db=async({packageJson:a,
packageJsonPath:c,packages:e,setupPath:f,packageName:h})=>{f=Oa({packages:e,setupPath:f,packageName:h});e=a.workspaces;f=void 0===e?f:("packages"in e?e.packages=f:e=f,e);a.workspaces=f;await Ie(c,a,{spaces:2})},oa=Object.keys(L),fb=a=>{a.command("generate <pkg> [path]").describe("Generate a new package.\n    Package name is required.\n    Path is optional. The path argument indicates where the folder with the package name should be generated.").alias("g").example("generate packageName").example("generate packageName .").example("generate packageName workspaces").option("t, template",
`Specify a template.
     Available templates: [${oa.join(", ")}]
     
     `).example(`generate packageName --template ${oa[0]}`).action(async(c,e,{template:f})=>{let h=c,g=f;const m=await z(),n=l.resolve(m,"package.json"),p=await d.readJSON(n),t=D(y.generating(c));try{const v=Ma(p.workspaces),G=e||Na(v);h=await Z({basePath:l.resolve(m,G),name:c,onPromptMessage:aa=>y.failed(aa),onPromptInitial:aa=>y.copy(aa)});const A=l.resolve(m,G,h);g=await bb(f,()=>{t.fail(y.invalidTemplate(f))});const T=await ma();t.start();N(T);await na({dir:A,bin:"generate",template:g});process.chdir(A);
const eb=cb({author:T,name:h,license:p.license,hostName:p.name,template:L[g]});await la({dir:A,preset:eb});await db({packageJsonPath:n,packageJson:p,packageName:h,packages:v,setupPath:G});t.succeed(y.successful(h))}catch(v){t.fail(y.failed(h)),u(v),process.exit(1)}({dependencies:c}=L[g]);c=D(y.preparingPackage(h,c.sort())).start();try{await x("npx sort-package-json",{silent:!0});const v=await x("yarn build",{silent:!0});if(0<v.code)throw Error(v.stderr);c.succeed(y.successfulConfigure());console.log(y.preparedPackage(h))}catch(v){c.fail(y.failedConfigure()),
u(v),process.exit(1)}})},gb=(a,c,e=Da)=>a in U?Promise.resolve(a):(e(),(new H({message:"Choose a feature",choices:c.map(f=>({name:f,message:k.info(f)}))})).run()),hb=(a,c)=>d.copy(W("add",c),l.resolve(a,U[c].path),{overwrite:!1,errorOnExist:!0}),ib=({dir:a,packageJson:c,option:e})=>d.outputJSON(a,{...c,scripts:{...c.scripts,...U[e].scripts}},{spaces:2}),pa=Object.keys(U),jb=a=>{a.command("add [featureName]").describe(`Embed ready-made feature [${pa.join(", ")}].`).example("add").example("add playground").action(async(c=
"")=>{const e=await gb(c,pa,()=>console.log(O.invalidFeatureName(e)));c=await I();const f=l.resolve(c,"package.json"),h=await d.readJSON(f),g=D(O.adding(e));g.start();try{await hb(c,e),await ib({dir:f,packageJson:h,option:e}),g.succeed(O.successful(e))}catch(m){g.fail(O.failed(e)),m.toString().includes("already exists")&&console.log(O.exists()),u(m),process.exit(1)}})},qa={cra:{packageJson:Fa}},kb=a=>{const c={Yes:w.changeFolder(),No:w.leaveCurrentFolder()};return(new H({message:k.error(`Would you like to choose a different path? 
  The specified path ${k.underline(`${a}`)} is already taken.
`),choices:["Yes","No"].map(e=>({name:e,message:c[e]}))})).run()},mb=async({name:a,dir:c})=>{if(!d.existsSync(c)||"Yes"!==await kb(c))return{projectDir:c,projectName:a};a=await lb(a);c=l.resolve(a);return{projectName:a,projectDir:c}},lb=async a=>Z({basePath:process.cwd(),name:a,onPromptInitial:w.initial,onPromptMessage:c=>w.existsPrompt(l.resolve(c))}),ra=Object.keys(qa),nb=a=>{a.command("new <name> [dir]").describe("Create a new React project (scaffolding).\n    Project name is required.\n    Directory is optional. However, if you specify dir, then template files will be installed there, even if this folder already exists, but without overwriting.").example("new projectName").example("new projectName .").example("new projectName projectDirectory").option("t, template",
`Specify a template.
     Available templates: [${ra.join(", ")}]
     
     `,"cra").example(`new projectName --template ${ra[0]}`).option("f, force","Skip folder checks",!1).action(async(c,e,{template:f,force:h})=>{const g=D();e=l.resolve(e||c);const {projectDir:m,projectName:n}=h?{projectDir:e,projectName:c}:await mb({name:c,dir:e});g.start(w.creating(m));try{await na({dir:m,bin:"new",template:f});g.stop();const p=await ma();N(p);g.start();process.chdir(m);await la({dir:m,preset:{...qa[f].packageJson,name:n,author:p}});g.succeed(w.created({dir:m,name:n}))}catch(p){g.fail(w.failed(n)),
u(p),process.exit(1)}c=D(w.preparing()).start();try{x("npx sort-package-json",{silent:!0}),x("yarn install",{silent:!0}),c.succeed(w.prepared())}catch(p){c.fail(w.failedPreparation()),u(p)}console.log(w.finish(m))})},sa=({packageJson:a,runEslint:c,displayFilesize:e,useClosure:f})=>({input:a.source,output:[{file:a.module,format:"es",sourcemap:!0},{file:a.main,format:"cjs",sourcemap:!0}],external:Ia(a),plugins:[Ye(),Xe({clearLine:!0}),c&&et(),e&&Qe(),f&&We(),He(),Ge(),qe(),Ve({extract:!1,modules:!0,
writeDefinitions:!0,plugins:[tt(),st(),ot({variables:{}}),nt()],extensions:[".css",".scss",".sass"],use:["sass"]}),Ue({clean:!0,tsconfigDefaults:{exclude:"**/*.spec.ts **/*.test.ts **/*.spec.tsx **/*.test.tsx node_modules dist".split(" "),compilerOptions:{rootDir:"./src",sourceMap:!0,declaration:!0,jsx:"react",target:"es5",lib:["dom","dom.iterable","esnext"],allowJs:!0,skipLibCheck:!0,esModuleInterop:!0,allowSyntheticDefaultImports:!0,strict:!0,forceConsistentCasingInFileNames:!0,module:"esnext",
moduleResolution:"node",resolveJsonModule:!0,isolatedModules:!0,noEmit:!0}}}),Le({include:/\/node_modules\//}),ze({extensions:[".js",".jsx",".ts",".tsx"],preferBuiltins:!1,browser:!0}),Ke({babelHelpers:"runtime",skipPreflightCheck:!0,babelrc:!1,extensions:[".js","jsx",".ts",".tsx"],presets:["@babel/preset-env","@babel/preset-react"],plugins:["@babel/plugin-transform-runtime","@babel/proposal-class-properties"],exclude:/\/node_modules\//}),Ze({start_comment:"placeholder:start",end_comment:"placeholder:end"})]}),
ob=async a=>{var c=await d.readJSON(l.resolve(a,"tsconfig.json"));a=await d.readJSON(l.resolve(a,"package.json"));await ia();const e=process.hrtime();c=sa({tsconfigJson:c,packageJson:a,displayFilesize:!0,runEslint:!1,useClosure:!1});console.log(ja.bundling(a));try{const f=await Be(c);await Promise.all(c.output.map(g=>f.write(g)));const h=process.hrtime(e);console.log(ja.successful(h))}catch(f){u(f),process.exit(1)}},pb=a=>{a.command("build").describe("Build a package.").alias("b").example("build").action(async()=>
{const c=await I();await ob(c)})},qb=async()=>{const a=[];let c="";try{c=await I(!0),a.push(l.resolve(c,"tsconfig.json"))}catch{}try{const e=""!==c,f=await z(e);e||(c=f);a.push(l.resolve(f,"tsconfig.json"))}catch{}return{dir:c,project:a}},rb=a=>{a.command("lint").describe("Lint a package (default lint pattern src/**/*.{js,jsx,ts,tsx}.").alias("l").option("fix","Resolve fixable eslint errors").example("lint --fix").option("ignore-path","Ignore a path").example("lint --ignore-path src/foo.ts").action(async c=>
{var e=process.hrtime(),f=0<c._.length?c._:["src/**/*.{js,jsx,ts,tsx}"];const {dir:h,project:g}=await qb();var m=l.resolve(h,"package.json");({eslintConfig:m={}}=await d.readJSON(m));var n=oe;var p={ignorePatterns:["*.*ss"],settings:{"import/resolver":{node:{paths:[l.resolve(h,"src")],extensions:[".js",".jsx",".ts",".tsx"]}},"import/parsers":{"@typescript-eslint/parser":[".ts",".tsx"]},react:{version:"detect"}},rules:{"import/no-unresolved":0},extends:"eslint:recommended react-app plugin:prettier/recommended plugin:react/recommended plugin:import/errors plugin:import/warnings plugin:import/typescript plugin:@typescript-eslint/recommended".split(" "),
parser:"@typescript-eslint/parser",parserOptions:{tsconfigRootDir:h,project:g}};m=new n({baseConfig:{...p,...m},extensions:[".ts",".tsx",".js",".jsx"],fix:c.fix,ignorePath:c["ignore-path"]});console.log(ka.linting(f));f=await m.lintFiles(f);c.fix&&await oe.outputFixes(f);c=await m.loadFormatter();console.log(c.format(f));e=process.hrtime(e);console.log(ka.linted(e));for(const t of f)t.errorCount&&process.exit(1)})},sb=async a=>{const c=await d.readJSON(l.resolve(a,"package.json"));a=await d.readJSON(l.resolve(a,
"tsconfig.json"));const e=sa({tsconfigJson:a,packageJson:c,displayFilesize:!1,runEslint:!1,useClosure:!1});let f=!0;return await ia(),new Promise(h=>{Re(e).on("event",async g=>{"BUNDLE_START"===g.code&&(K(),console.log(B.introduce()),console.log(B.bundles(c)),console.log(B.compiling()));"ERROR"===g.code&&(console.log(B.failed()),u(g.error));"BUNDLE_END"===g.code&&(console.log(B.compiled(f)),console.log(B.bundled({isFirstChange:f,module:c.module,duration:g.duration})));"END"===g.code&&(f=!1,console.log(B.watching()),
h())})})},tb=a=>{a.command("watch").describe("Rebuild a package on change.").alias("w","start").example("watch").action(async()=>{const c=await I();await sb(c)})},ub=({rootDir:a,jestPackageOptions:c,jestConfigOptions:e})=>({rootDir:a,moduleFileExtensions:"ts tsx js jsx json node".split(" "),transform:{".(ts|tsx)$":require.resolve("ts-jest/dist"),".(js|jsx)$":require.resolve("babel-jest")},transformIgnorePatterns:["[/\\\\]node_modules[/\\\\].+\\.(js|jsx)$"],testMatch:["<rootDir>/**/*.(spec|test).{ts,tsx,js,jsx}"],
moduleNameMapper:{"\\.(jpg|ico|jpeg|png|gif|eot|otf|webp|svg|ttf|woff|woff2|mp4|webm|wav|mp3|m4a|aac|oga)$":"identity-obj-proxy","\\.(css|less|scss|sass)$":"identity-obj-proxy"},roots:[l.resolve(a,"src")],moduleDirectories:["node_modules","src"],testPathIgnorePatterns:[l.resolve(a,"node_modules/")],...c,...e}),vb=async(a,c)=>{try{if(c){const h=l.resolve(a,c);process.argv.splice(process.argv.indexOf("--config"),2);const g=c.split(".");return"js"===g[g.length-1]?require(h):await d.readJSON(h)}const e=
l.resolve(a,"jest.config.js"),f=l.resolve(a,"jest.config.json");if(d.existsSync(e))return require(e);if(d.existsSync(f))return await d.readJSON(f)}catch{}return{}},wb=a=>{a.command("test").describe("Test a package.").alias("t").option("config","Specify a path to the jest config").action(async c=>{process.env.NODE_ENV="test";process.env.BABEL_ENV="test";var e=await I(),f=l.resolve(e,"package.json");c=await vb(e,c.config);({jest:f}=await d.readJSON(f));e=ub({rootDir:e,jestPackageOptions:f,jestConfigOptions:c});
at([...process.argv.slice(3),"--config",JSON.stringify({...e})])})},xb=a=>{a.command("install").describe("Install one or more dependencies to the workspace (host). \n      If you run this command inside some package, then it will be added to the package (as dev or peer dependency)").alias("i").example("install libraryName").option("dev, D","Install development dependencies").example("install libraryName --dev").action(async({_:c,dev:e})=>{const f=c.join(" "),h=D(Y.installing(f));h.start();try{var g=
await I(!0);const m=["add"];e?m.push("--dev"):m.push("--peer");for(const n of c)m.push(n);await b("yarn",m,{cwd:g})}catch{}try{const m=await z(!0);g=["add","--exact","-W"];e&&g.push("--dev");"string"==typeof e&&c.push(e);for(const n of c)g.push(n);await b("yarn",g,{cwd:m});h.succeed(Y.successful(f))}catch(m){h.fail(Y.failed(f)),u(m),process.exit(1)}})},M=Ne("monoreact");console.log(Pa);(a=>{pb(a);rb(a);tb(a);wb(a);xb(a)})(M);(a=>{a.command("migration detach").describe("Add all necessary settings to separate the package from the workspace.").alias("mi").example("migration detach").action(async()=>
{const c=D(X.generating()),e=await I();c.start();try{await Xa(e),await Ya(e),await d.copy(W("migration","detach"),e,{overwrite:!0,errorOnExist:!1}),await x("yarn install",{silent:!0}),c.succeed(X.successful())}catch(f){c.fail(X.failed()),u(f),process.exit(1)}})})(M);(a=>{jb(a);fb(a);nb(a)})(M);(a=>{ua(a);va(a);wa(a);ya(a)})(M);(a=>{za(a);Ba(a);Ca(a);Aa(a)})(M);M.version(r.version).parse(process.argv)})()
